// Copyright © 2019 - 2020 Oscar Campos <oscar.campos@thepimpam.com>
// Copyright © 2017 - William Edwards
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef CGDNATIVE_CORE_H
#define CGDNATIVE_CORE_H

#include <gdnative/aabb.h>
#include <gdnative/array.h>
#include <gdnative/basis.h>
#include <gdnative/color.h>
#include <gdnative/dictionary.h>
#include <gdnative/gdnative.h>
#include <gdnative/node_path.h>
#include <gdnative/plane.h>
#include <gdnative/pool_arrays.h>
#include <gdnative/quat.h>
#include <gdnative/rect2.h>
#include <gdnative/rid.h>
#include <gdnative/string.h>
#include <gdnative/string_name.h>
#include <gdnative/transform.h>
#include <gdnative/transform2d.h>
#include <gdnative/variant.h>
#include <gdnative/vector2.h>
#include <gdnative/vector3.h>
#include <gdnative_api_struct.gen.h>

/*------------------------------------------------------------------------------
//   This file was autogenerated by PimPam GDNative-Go binding tools
//   Please do not modify this file, any change will be lost
//----------------------------------------------------------------------------*/


/* GDNative CORE 1.0 */
void go_godot_color_new_rgba(godot_gdnative_core_api_struct * p_api, godot_color * r_dest, const godot_real p_r, const godot_real p_g, const godot_real p_b, const godot_real p_a);
void go_godot_color_new_rgb(godot_gdnative_core_api_struct * p_api, godot_color * r_dest, const godot_real p_r, const godot_real p_g, const godot_real p_b);
godot_real go_godot_color_get_r(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
void go_godot_color_set_r(godot_gdnative_core_api_struct * p_api, godot_color * p_self, const godot_real r);
godot_real go_godot_color_get_g(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
void go_godot_color_set_g(godot_gdnative_core_api_struct * p_api, godot_color * p_self, const godot_real g);
godot_real go_godot_color_get_b(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
void go_godot_color_set_b(godot_gdnative_core_api_struct * p_api, godot_color * p_self, const godot_real b);
godot_real go_godot_color_get_a(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
void go_godot_color_set_a(godot_gdnative_core_api_struct * p_api, godot_color * p_self, const godot_real a);
godot_real go_godot_color_get_h(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
godot_real go_godot_color_get_s(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
godot_real go_godot_color_get_v(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
godot_string go_godot_color_as_string(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
godot_int go_godot_color_to_rgba32(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
godot_int go_godot_color_to_argb32(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
godot_real go_godot_color_gray(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
godot_color go_godot_color_inverted(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
godot_color go_godot_color_contrasted(godot_gdnative_core_api_struct * p_api, const godot_color * p_self);
godot_color go_godot_color_linear_interpolate(godot_gdnative_core_api_struct * p_api, const godot_color * p_self, const godot_color * p_b, const godot_real p_t);
godot_color go_godot_color_blend(godot_gdnative_core_api_struct * p_api, const godot_color * p_self, const godot_color * p_over);
godot_string go_godot_color_to_html(godot_gdnative_core_api_struct * p_api, const godot_color * p_self, const godot_bool p_with_alpha);
godot_bool go_godot_color_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_color * p_self, const godot_color * p_b);
godot_bool go_godot_color_operator_less(godot_gdnative_core_api_struct * p_api, const godot_color * p_self, const godot_color * p_b);
void go_godot_vector2_new(godot_gdnative_core_api_struct * p_api, godot_vector2 * r_dest, const godot_real p_x, const godot_real p_y);
godot_string go_godot_vector2_as_string(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
godot_vector2 go_godot_vector2_normalized(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
godot_real go_godot_vector2_length(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
godot_real go_godot_vector2_angle(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
godot_real go_godot_vector2_length_squared(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
godot_bool go_godot_vector2_is_normalized(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
godot_real go_godot_vector2_distance_to(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_to);
godot_real go_godot_vector2_distance_squared_to(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_to);
godot_real go_godot_vector2_angle_to(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_to);
godot_real go_godot_vector2_angle_to_point(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_to);
godot_vector2 go_godot_vector2_linear_interpolate(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_b, const godot_real p_t);
godot_vector2 go_godot_vector2_cubic_interpolate(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_b, const godot_vector2 * p_pre_a, const godot_vector2 * p_post_b, const godot_real p_t);
godot_vector2 go_godot_vector2_rotated(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_real p_phi);
godot_vector2 go_godot_vector2_tangent(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
godot_vector2 go_godot_vector2_floor(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
godot_vector2 go_godot_vector2_snapped(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_by);
godot_real go_godot_vector2_aspect(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
godot_real go_godot_vector2_dot(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_with);
godot_vector2 go_godot_vector2_slide(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_n);
godot_vector2 go_godot_vector2_bounce(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_n);
godot_vector2 go_godot_vector2_reflect(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_n);
godot_vector2 go_godot_vector2_abs(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
godot_vector2 go_godot_vector2_clamped(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_real p_length);
godot_vector2 go_godot_vector2_operator_add(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_b);
godot_vector2 go_godot_vector2_operator_subtract(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_b);
godot_vector2 go_godot_vector2_operator_multiply_vector(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_b);
godot_vector2 go_godot_vector2_operator_multiply_scalar(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_real p_b);
godot_vector2 go_godot_vector2_operator_divide_vector(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_b);
godot_vector2 go_godot_vector2_operator_divide_scalar(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_real p_b);
godot_bool go_godot_vector2_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_b);
godot_bool go_godot_vector2_operator_less(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self, const godot_vector2 * p_b);
godot_vector2 go_godot_vector2_operator_neg(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
void go_godot_vector2_set_x(godot_gdnative_core_api_struct * p_api, godot_vector2 * p_self, const godot_real p_x);
void go_godot_vector2_set_y(godot_gdnative_core_api_struct * p_api, godot_vector2 * p_self, const godot_real p_y);
godot_real go_godot_vector2_get_x(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
godot_real go_godot_vector2_get_y(godot_gdnative_core_api_struct * p_api, const godot_vector2 * p_self);
void go_godot_quat_new(godot_gdnative_core_api_struct * p_api, godot_quat * r_dest, const godot_real p_x, const godot_real p_y, const godot_real p_z, const godot_real p_w);
void go_godot_quat_new_with_axis_angle(godot_gdnative_core_api_struct * p_api, godot_quat * r_dest, const godot_vector3 * p_axis, const godot_real p_angle);
godot_real go_godot_quat_get_x(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self);
void go_godot_quat_set_x(godot_gdnative_core_api_struct * p_api, godot_quat * p_self, const godot_real val);
godot_real go_godot_quat_get_y(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self);
void go_godot_quat_set_y(godot_gdnative_core_api_struct * p_api, godot_quat * p_self, const godot_real val);
godot_real go_godot_quat_get_z(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self);
void go_godot_quat_set_z(godot_gdnative_core_api_struct * p_api, godot_quat * p_self, const godot_real val);
godot_real go_godot_quat_get_w(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self);
void go_godot_quat_set_w(godot_gdnative_core_api_struct * p_api, godot_quat * p_self, const godot_real val);
godot_string go_godot_quat_as_string(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self);
godot_real go_godot_quat_length(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self);
godot_real go_godot_quat_length_squared(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self);
godot_quat go_godot_quat_normalized(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self);
godot_bool go_godot_quat_is_normalized(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self);
godot_quat go_godot_quat_inverse(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self);
godot_real go_godot_quat_dot(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self, const godot_quat * p_b);
godot_vector3 go_godot_quat_xform(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self, const godot_vector3 * p_v);
godot_quat go_godot_quat_slerp(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self, const godot_quat * p_b, const godot_real p_t);
godot_quat go_godot_quat_slerpni(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self, const godot_quat * p_b, const godot_real p_t);
godot_quat go_godot_quat_cubic_slerp(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self, const godot_quat * p_b, const godot_quat * p_pre_a, const godot_quat * p_post_b, const godot_real p_t);
godot_quat go_godot_quat_operator_multiply(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self, const godot_real p_b);
godot_quat go_godot_quat_operator_add(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self, const godot_quat * p_b);
godot_quat go_godot_quat_operator_subtract(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self, const godot_quat * p_b);
godot_quat go_godot_quat_operator_divide(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self, const godot_real p_b);
godot_bool go_godot_quat_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self, const godot_quat * p_b);
godot_quat go_godot_quat_operator_neg(godot_gdnative_core_api_struct * p_api, const godot_quat * p_self);
void go_godot_basis_new_with_rows(godot_gdnative_core_api_struct * p_api, godot_basis * r_dest, const godot_vector3 * p_x_axis, const godot_vector3 * p_y_axis, const godot_vector3 * p_z_axis);
void go_godot_basis_new_with_axis_and_angle(godot_gdnative_core_api_struct * p_api, godot_basis * r_dest, const godot_vector3 * p_axis, const godot_real p_phi);
void go_godot_basis_new_with_euler(godot_gdnative_core_api_struct * p_api, godot_basis * r_dest, const godot_vector3 * p_euler);
godot_string go_godot_basis_as_string(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self);
godot_basis go_godot_basis_inverse(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self);
godot_basis go_godot_basis_transposed(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self);
godot_basis go_godot_basis_orthonormalized(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self);
godot_real go_godot_basis_determinant(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self);
godot_basis go_godot_basis_rotated(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_vector3 * p_axis, const godot_real p_phi);
godot_basis go_godot_basis_scaled(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_vector3 * p_scale);
godot_vector3 go_godot_basis_get_scale(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self);
godot_vector3 go_godot_basis_get_euler(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self);
godot_real go_godot_basis_tdotx(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_vector3 * p_with);
godot_real go_godot_basis_tdoty(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_vector3 * p_with);
godot_real go_godot_basis_tdotz(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_vector3 * p_with);
godot_vector3 go_godot_basis_xform(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_vector3 * p_v);
godot_vector3 go_godot_basis_xform_inv(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_vector3 * p_v);
godot_int go_godot_basis_get_orthogonal_index(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self);
void go_godot_basis_new(godot_gdnative_core_api_struct * p_api, godot_basis * r_dest);
void go_godot_basis_new_with_euler_quat(godot_gdnative_core_api_struct * p_api, godot_basis * r_dest, const godot_quat * p_euler);
void go_godot_basis_get_elements(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, godot_vector3 * p_elements);
godot_vector3 go_godot_basis_get_axis(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_int p_axis);
void go_godot_basis_set_axis(godot_gdnative_core_api_struct * p_api, godot_basis * p_self, const godot_int p_axis, const godot_vector3 * p_value);
godot_vector3 go_godot_basis_get_row(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_int p_row);
void go_godot_basis_set_row(godot_gdnative_core_api_struct * p_api, godot_basis * p_self, const godot_int p_row, const godot_vector3 * p_value);
godot_bool go_godot_basis_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_basis * p_b);
godot_basis go_godot_basis_operator_add(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_basis * p_b);
godot_basis go_godot_basis_operator_subtract(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_basis * p_b);
godot_basis go_godot_basis_operator_multiply_vector(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_basis * p_b);
godot_basis go_godot_basis_operator_multiply_scalar(godot_gdnative_core_api_struct * p_api, const godot_basis * p_self, const godot_real p_b);
void go_godot_vector3_new(godot_gdnative_core_api_struct * p_api, godot_vector3 * r_dest, const godot_real p_x, const godot_real p_y, const godot_real p_z);
godot_string go_godot_vector3_as_string(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_int go_godot_vector3_min_axis(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_int go_godot_vector3_max_axis(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_real go_godot_vector3_length(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_real go_godot_vector3_length_squared(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_bool go_godot_vector3_is_normalized(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_vector3 go_godot_vector3_normalized(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_vector3 go_godot_vector3_inverse(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_vector3 go_godot_vector3_snapped(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_by);
godot_vector3 go_godot_vector3_rotated(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_axis, const godot_real p_phi);
godot_vector3 go_godot_vector3_linear_interpolate(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b, const godot_real p_t);
godot_vector3 go_godot_vector3_cubic_interpolate(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b, const godot_vector3 * p_pre_a, const godot_vector3 * p_post_b, const godot_real p_t);
godot_real go_godot_vector3_dot(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b);
godot_vector3 go_godot_vector3_cross(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b);
godot_basis go_godot_vector3_outer(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b);
godot_basis go_godot_vector3_to_diagonal_matrix(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_vector3 go_godot_vector3_abs(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_vector3 go_godot_vector3_floor(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_vector3 go_godot_vector3_ceil(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
godot_real go_godot_vector3_distance_to(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b);
godot_real go_godot_vector3_distance_squared_to(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b);
godot_real go_godot_vector3_angle_to(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_to);
godot_vector3 go_godot_vector3_slide(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_n);
godot_vector3 go_godot_vector3_bounce(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_n);
godot_vector3 go_godot_vector3_reflect(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_n);
godot_vector3 go_godot_vector3_operator_add(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b);
godot_vector3 go_godot_vector3_operator_subtract(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b);
godot_vector3 go_godot_vector3_operator_multiply_vector(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b);
godot_vector3 go_godot_vector3_operator_multiply_scalar(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_real p_b);
godot_vector3 go_godot_vector3_operator_divide_vector(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b);
godot_vector3 go_godot_vector3_operator_divide_scalar(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_real p_b);
godot_bool go_godot_vector3_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b);
godot_bool go_godot_vector3_operator_less(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3 * p_b);
godot_vector3 go_godot_vector3_operator_neg(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self);
void go_godot_vector3_set_axis(godot_gdnative_core_api_struct * p_api, godot_vector3 * p_self, const godot_vector3_axis p_axis, const godot_real p_val);
godot_real go_godot_vector3_get_axis(godot_gdnative_core_api_struct * p_api, const godot_vector3 * p_self, const godot_vector3_axis p_axis);
void go_godot_pool_byte_array_new(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * r_dest);
void go_godot_pool_byte_array_new_copy(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * r_dest, const godot_pool_byte_array * p_src);
void go_godot_pool_byte_array_new_with_array(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * r_dest, const godot_array * p_a);
void go_godot_pool_byte_array_append(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * p_self, const uint8_t p_data);
void go_godot_pool_byte_array_append_array(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * p_self, const godot_pool_byte_array * p_array);
godot_error go_godot_pool_byte_array_insert(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * p_self, const godot_int p_idx, const uint8_t p_data);
void go_godot_pool_byte_array_invert(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * p_self);
void go_godot_pool_byte_array_push_back(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * p_self, const uint8_t p_data);
void go_godot_pool_byte_array_remove(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * p_self, const godot_int p_idx);
void go_godot_pool_byte_array_resize(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * p_self, const godot_int p_size);
godot_pool_byte_array_read_access * go_godot_pool_byte_array_read(godot_gdnative_core_api_struct * p_api, const godot_pool_byte_array * p_self);
godot_pool_byte_array_write_access * go_godot_pool_byte_array_write(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * p_self);
void go_godot_pool_byte_array_set(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * p_self, const godot_int p_idx, const uint8_t p_data);
uint8_t go_godot_pool_byte_array_get(godot_gdnative_core_api_struct * p_api, const godot_pool_byte_array * p_self, const godot_int p_idx);
godot_int go_godot_pool_byte_array_size(godot_gdnative_core_api_struct * p_api, const godot_pool_byte_array * p_self);
void go_godot_pool_byte_array_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array * p_self);
void go_godot_pool_int_array_new(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * r_dest);
void go_godot_pool_int_array_new_copy(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * r_dest, const godot_pool_int_array * p_src);
void go_godot_pool_int_array_new_with_array(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * r_dest, const godot_array * p_a);
void go_godot_pool_int_array_append(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * p_self, const godot_int p_data);
void go_godot_pool_int_array_append_array(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * p_self, const godot_pool_int_array * p_array);
godot_error go_godot_pool_int_array_insert(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * p_self, const godot_int p_idx, const godot_int p_data);
void go_godot_pool_int_array_invert(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * p_self);
void go_godot_pool_int_array_push_back(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * p_self, const godot_int p_data);
void go_godot_pool_int_array_remove(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * p_self, const godot_int p_idx);
void go_godot_pool_int_array_resize(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * p_self, const godot_int p_size);
godot_pool_int_array_read_access * go_godot_pool_int_array_read(godot_gdnative_core_api_struct * p_api, const godot_pool_int_array * p_self);
godot_pool_int_array_write_access * go_godot_pool_int_array_write(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * p_self);
void go_godot_pool_int_array_set(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * p_self, const godot_int p_idx, const godot_int p_data);
godot_int go_godot_pool_int_array_get(godot_gdnative_core_api_struct * p_api, const godot_pool_int_array * p_self, const godot_int p_idx);
godot_int go_godot_pool_int_array_size(godot_gdnative_core_api_struct * p_api, const godot_pool_int_array * p_self);
void go_godot_pool_int_array_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_int_array * p_self);
void go_godot_pool_real_array_new(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * r_dest);
void go_godot_pool_real_array_new_copy(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * r_dest, const godot_pool_real_array * p_src);
void go_godot_pool_real_array_new_with_array(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * r_dest, const godot_array * p_a);
void go_godot_pool_real_array_append(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * p_self, const godot_real p_data);
void go_godot_pool_real_array_append_array(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * p_self, const godot_pool_real_array * p_array);
godot_error go_godot_pool_real_array_insert(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * p_self, const godot_int p_idx, const godot_real p_data);
void go_godot_pool_real_array_invert(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * p_self);
void go_godot_pool_real_array_push_back(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * p_self, const godot_real p_data);
void go_godot_pool_real_array_remove(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * p_self, const godot_int p_idx);
void go_godot_pool_real_array_resize(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * p_self, const godot_int p_size);
godot_pool_real_array_read_access * go_godot_pool_real_array_read(godot_gdnative_core_api_struct * p_api, const godot_pool_real_array * p_self);
godot_pool_real_array_write_access * go_godot_pool_real_array_write(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * p_self);
void go_godot_pool_real_array_set(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * p_self, const godot_int p_idx, const godot_real p_data);
godot_real go_godot_pool_real_array_get(godot_gdnative_core_api_struct * p_api, const godot_pool_real_array * p_self, const godot_int p_idx);
godot_int go_godot_pool_real_array_size(godot_gdnative_core_api_struct * p_api, const godot_pool_real_array * p_self);
void go_godot_pool_real_array_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_real_array * p_self);
void go_godot_pool_string_array_new(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * r_dest);
void go_godot_pool_string_array_new_copy(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * r_dest, const godot_pool_string_array * p_src);
void go_godot_pool_string_array_new_with_array(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * r_dest, const godot_array * p_a);
void go_godot_pool_string_array_append(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * p_self, const godot_string * p_data);
void go_godot_pool_string_array_append_array(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * p_self, const godot_pool_string_array * p_array);
godot_error go_godot_pool_string_array_insert(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * p_self, const godot_int p_idx, const godot_string * p_data);
void go_godot_pool_string_array_invert(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * p_self);
void go_godot_pool_string_array_push_back(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * p_self, const godot_string * p_data);
void go_godot_pool_string_array_remove(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * p_self, const godot_int p_idx);
void go_godot_pool_string_array_resize(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * p_self, const godot_int p_size);
godot_pool_string_array_read_access * go_godot_pool_string_array_read(godot_gdnative_core_api_struct * p_api, const godot_pool_string_array * p_self);
godot_pool_string_array_write_access * go_godot_pool_string_array_write(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * p_self);
void go_godot_pool_string_array_set(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * p_self, const godot_int p_idx, const godot_string * p_data);
godot_string go_godot_pool_string_array_get(godot_gdnative_core_api_struct * p_api, const godot_pool_string_array * p_self, const godot_int p_idx);
godot_int go_godot_pool_string_array_size(godot_gdnative_core_api_struct * p_api, const godot_pool_string_array * p_self);
void go_godot_pool_string_array_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_string_array * p_self);
void go_godot_pool_vector2_array_new(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * r_dest);
void go_godot_pool_vector2_array_new_copy(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * r_dest, const godot_pool_vector2_array * p_src);
void go_godot_pool_vector2_array_new_with_array(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * r_dest, const godot_array * p_a);
void go_godot_pool_vector2_array_append(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * p_self, const godot_vector2 * p_data);
void go_godot_pool_vector2_array_append_array(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * p_self, const godot_pool_vector2_array * p_array);
godot_error go_godot_pool_vector2_array_insert(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * p_self, const godot_int p_idx, const godot_vector2 * p_data);
void go_godot_pool_vector2_array_invert(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * p_self);
void go_godot_pool_vector2_array_push_back(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * p_self, const godot_vector2 * p_data);
void go_godot_pool_vector2_array_remove(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * p_self, const godot_int p_idx);
void go_godot_pool_vector2_array_resize(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * p_self, const godot_int p_size);
godot_pool_vector2_array_read_access * go_godot_pool_vector2_array_read(godot_gdnative_core_api_struct * p_api, const godot_pool_vector2_array * p_self);
godot_pool_vector2_array_write_access * go_godot_pool_vector2_array_write(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * p_self);
void go_godot_pool_vector2_array_set(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * p_self, const godot_int p_idx, const godot_vector2 * p_data);
godot_vector2 go_godot_pool_vector2_array_get(godot_gdnative_core_api_struct * p_api, const godot_pool_vector2_array * p_self, const godot_int p_idx);
godot_int go_godot_pool_vector2_array_size(godot_gdnative_core_api_struct * p_api, const godot_pool_vector2_array * p_self);
void go_godot_pool_vector2_array_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array * p_self);
void go_godot_pool_vector3_array_new(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * r_dest);
void go_godot_pool_vector3_array_new_copy(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * r_dest, const godot_pool_vector3_array * p_src);
void go_godot_pool_vector3_array_new_with_array(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * r_dest, const godot_array * p_a);
void go_godot_pool_vector3_array_append(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * p_self, const godot_vector3 * p_data);
void go_godot_pool_vector3_array_append_array(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * p_self, const godot_pool_vector3_array * p_array);
godot_error go_godot_pool_vector3_array_insert(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * p_self, const godot_int p_idx, const godot_vector3 * p_data);
void go_godot_pool_vector3_array_invert(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * p_self);
void go_godot_pool_vector3_array_push_back(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * p_self, const godot_vector3 * p_data);
void go_godot_pool_vector3_array_remove(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * p_self, const godot_int p_idx);
void go_godot_pool_vector3_array_resize(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * p_self, const godot_int p_size);
godot_pool_vector3_array_read_access * go_godot_pool_vector3_array_read(godot_gdnative_core_api_struct * p_api, const godot_pool_vector3_array * p_self);
godot_pool_vector3_array_write_access * go_godot_pool_vector3_array_write(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * p_self);
void go_godot_pool_vector3_array_set(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * p_self, const godot_int p_idx, const godot_vector3 * p_data);
godot_vector3 go_godot_pool_vector3_array_get(godot_gdnative_core_api_struct * p_api, const godot_pool_vector3_array * p_self, const godot_int p_idx);
godot_int go_godot_pool_vector3_array_size(godot_gdnative_core_api_struct * p_api, const godot_pool_vector3_array * p_self);
void go_godot_pool_vector3_array_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array * p_self);
void go_godot_pool_color_array_new(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * r_dest);
void go_godot_pool_color_array_new_copy(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * r_dest, const godot_pool_color_array * p_src);
void go_godot_pool_color_array_new_with_array(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * r_dest, const godot_array * p_a);
void go_godot_pool_color_array_append(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * p_self, const godot_color * p_data);
void go_godot_pool_color_array_append_array(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * p_self, const godot_pool_color_array * p_array);
godot_error go_godot_pool_color_array_insert(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * p_self, const godot_int p_idx, const godot_color * p_data);
void go_godot_pool_color_array_invert(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * p_self);
void go_godot_pool_color_array_push_back(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * p_self, const godot_color * p_data);
void go_godot_pool_color_array_remove(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * p_self, const godot_int p_idx);
void go_godot_pool_color_array_resize(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * p_self, const godot_int p_size);
godot_pool_color_array_read_access * go_godot_pool_color_array_read(godot_gdnative_core_api_struct * p_api, const godot_pool_color_array * p_self);
godot_pool_color_array_write_access * go_godot_pool_color_array_write(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * p_self);
void go_godot_pool_color_array_set(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * p_self, const godot_int p_idx, const godot_color * p_data);
godot_color go_godot_pool_color_array_get(godot_gdnative_core_api_struct * p_api, const godot_pool_color_array * p_self, const godot_int p_idx);
godot_int go_godot_pool_color_array_size(godot_gdnative_core_api_struct * p_api, const godot_pool_color_array * p_self);
void go_godot_pool_color_array_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_color_array * p_self);
godot_pool_byte_array_read_access * go_godot_pool_byte_array_read_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_byte_array_read_access * p_read);
const uint8_t * go_godot_pool_byte_array_read_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_byte_array_read_access * p_read);
void go_godot_pool_byte_array_read_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array_read_access * p_read, godot_pool_byte_array_read_access * p_other);
void go_godot_pool_byte_array_read_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array_read_access * p_read);
godot_pool_int_array_read_access * go_godot_pool_int_array_read_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_int_array_read_access * p_read);
const godot_int * go_godot_pool_int_array_read_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_int_array_read_access * p_read);
void go_godot_pool_int_array_read_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_int_array_read_access * p_read, godot_pool_int_array_read_access * p_other);
void go_godot_pool_int_array_read_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_int_array_read_access * p_read);
godot_pool_real_array_read_access * go_godot_pool_real_array_read_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_real_array_read_access * p_read);
const godot_real * go_godot_pool_real_array_read_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_real_array_read_access * p_read);
void go_godot_pool_real_array_read_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_real_array_read_access * p_read, godot_pool_real_array_read_access * p_other);
void go_godot_pool_real_array_read_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_real_array_read_access * p_read);
godot_pool_string_array_read_access * go_godot_pool_string_array_read_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_string_array_read_access * p_read);
const godot_string * go_godot_pool_string_array_read_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_string_array_read_access * p_read);
void go_godot_pool_string_array_read_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_string_array_read_access * p_read, godot_pool_string_array_read_access * p_other);
void go_godot_pool_string_array_read_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_string_array_read_access * p_read);
godot_pool_vector2_array_read_access * go_godot_pool_vector2_array_read_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_vector2_array_read_access * p_read);
const godot_vector2 * go_godot_pool_vector2_array_read_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_vector2_array_read_access * p_read);
void go_godot_pool_vector2_array_read_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array_read_access * p_read, godot_pool_vector2_array_read_access * p_other);
void go_godot_pool_vector2_array_read_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array_read_access * p_read);
godot_pool_vector3_array_read_access * go_godot_pool_vector3_array_read_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_vector3_array_read_access * p_read);
const godot_vector3 * go_godot_pool_vector3_array_read_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_vector3_array_read_access * p_read);
void go_godot_pool_vector3_array_read_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array_read_access * p_read, godot_pool_vector3_array_read_access * p_other);
void go_godot_pool_vector3_array_read_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array_read_access * p_read);
godot_pool_color_array_read_access * go_godot_pool_color_array_read_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_color_array_read_access * p_read);
const godot_color * go_godot_pool_color_array_read_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_color_array_read_access * p_read);
void go_godot_pool_color_array_read_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_color_array_read_access * p_read, godot_pool_color_array_read_access * p_other);
void go_godot_pool_color_array_read_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_color_array_read_access * p_read);
godot_pool_byte_array_write_access * go_godot_pool_byte_array_write_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_byte_array_write_access * p_write);
uint8_t * go_godot_pool_byte_array_write_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_byte_array_write_access * p_write);
void go_godot_pool_byte_array_write_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array_write_access * p_write, godot_pool_byte_array_write_access * p_other);
void go_godot_pool_byte_array_write_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_byte_array_write_access * p_write);
godot_pool_int_array_write_access * go_godot_pool_int_array_write_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_int_array_write_access * p_write);
godot_int * go_godot_pool_int_array_write_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_int_array_write_access * p_write);
void go_godot_pool_int_array_write_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_int_array_write_access * p_write, godot_pool_int_array_write_access * p_other);
void go_godot_pool_int_array_write_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_int_array_write_access * p_write);
godot_pool_real_array_write_access * go_godot_pool_real_array_write_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_real_array_write_access * p_write);
godot_real * go_godot_pool_real_array_write_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_real_array_write_access * p_write);
void go_godot_pool_real_array_write_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_real_array_write_access * p_write, godot_pool_real_array_write_access * p_other);
void go_godot_pool_real_array_write_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_real_array_write_access * p_write);
godot_pool_string_array_write_access * go_godot_pool_string_array_write_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_string_array_write_access * p_write);
godot_string * go_godot_pool_string_array_write_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_string_array_write_access * p_write);
void go_godot_pool_string_array_write_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_string_array_write_access * p_write, godot_pool_string_array_write_access * p_other);
void go_godot_pool_string_array_write_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_string_array_write_access * p_write);
godot_pool_vector2_array_write_access * go_godot_pool_vector2_array_write_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_vector2_array_write_access * p_write);
godot_vector2 * go_godot_pool_vector2_array_write_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_vector2_array_write_access * p_write);
void go_godot_pool_vector2_array_write_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array_write_access * p_write, godot_pool_vector2_array_write_access * p_other);
void go_godot_pool_vector2_array_write_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_vector2_array_write_access * p_write);
godot_pool_vector3_array_write_access * go_godot_pool_vector3_array_write_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_vector3_array_write_access * p_write);
godot_vector3 * go_godot_pool_vector3_array_write_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_vector3_array_write_access * p_write);
void go_godot_pool_vector3_array_write_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array_write_access * p_write, godot_pool_vector3_array_write_access * p_other);
void go_godot_pool_vector3_array_write_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_vector3_array_write_access * p_write);
godot_pool_color_array_write_access * go_godot_pool_color_array_write_access_copy(godot_gdnative_core_api_struct * p_api, const godot_pool_color_array_write_access * p_write);
godot_color * go_godot_pool_color_array_write_access_ptr(godot_gdnative_core_api_struct * p_api, const godot_pool_color_array_write_access * p_write);
void go_godot_pool_color_array_write_access_operator_assign(godot_gdnative_core_api_struct * p_api, godot_pool_color_array_write_access * p_write, godot_pool_color_array_write_access * p_other);
void go_godot_pool_color_array_write_access_destroy(godot_gdnative_core_api_struct * p_api, godot_pool_color_array_write_access * p_write);
void go_godot_array_new(godot_gdnative_core_api_struct * p_api, godot_array * r_dest);
void go_godot_array_new_copy(godot_gdnative_core_api_struct * p_api, godot_array * r_dest, const godot_array * p_src);
void go_godot_array_new_pool_color_array(godot_gdnative_core_api_struct * p_api, godot_array * r_dest, const godot_pool_color_array * p_pca);
void go_godot_array_new_pool_vector3_array(godot_gdnative_core_api_struct * p_api, godot_array * r_dest, const godot_pool_vector3_array * p_pv3a);
void go_godot_array_new_pool_vector2_array(godot_gdnative_core_api_struct * p_api, godot_array * r_dest, const godot_pool_vector2_array * p_pv2a);
void go_godot_array_new_pool_string_array(godot_gdnative_core_api_struct * p_api, godot_array * r_dest, const godot_pool_string_array * p_psa);
void go_godot_array_new_pool_real_array(godot_gdnative_core_api_struct * p_api, godot_array * r_dest, const godot_pool_real_array * p_pra);
void go_godot_array_new_pool_int_array(godot_gdnative_core_api_struct * p_api, godot_array * r_dest, const godot_pool_int_array * p_pia);
void go_godot_array_new_pool_byte_array(godot_gdnative_core_api_struct * p_api, godot_array * r_dest, const godot_pool_byte_array * p_pba);
void go_godot_array_set(godot_gdnative_core_api_struct * p_api, godot_array * p_self, const godot_int p_idx, const godot_variant * p_value);
godot_variant go_godot_array_get(godot_gdnative_core_api_struct * p_api, const godot_array * p_self, const godot_int p_idx);
godot_variant * go_godot_array_operator_index(godot_gdnative_core_api_struct * p_api, godot_array * p_self, const godot_int p_idx);
const godot_variant * go_godot_array_operator_index_const(godot_gdnative_core_api_struct * p_api, const godot_array * p_self, const godot_int p_idx);
void go_godot_array_append(godot_gdnative_core_api_struct * p_api, godot_array * p_self, const godot_variant * p_value);
void go_godot_array_clear(godot_gdnative_core_api_struct * p_api, godot_array * p_self);
godot_int go_godot_array_count(godot_gdnative_core_api_struct * p_api, const godot_array * p_self, const godot_variant * p_value);
godot_bool go_godot_array_empty(godot_gdnative_core_api_struct * p_api, const godot_array * p_self);
void go_godot_array_erase(godot_gdnative_core_api_struct * p_api, godot_array * p_self, const godot_variant * p_value);
godot_variant go_godot_array_front(godot_gdnative_core_api_struct * p_api, const godot_array * p_self);
godot_variant go_godot_array_back(godot_gdnative_core_api_struct * p_api, const godot_array * p_self);
godot_int go_godot_array_find(godot_gdnative_core_api_struct * p_api, const godot_array * p_self, const godot_variant * p_what, const godot_int p_from);
godot_int go_godot_array_find_last(godot_gdnative_core_api_struct * p_api, const godot_array * p_self, const godot_variant * p_what);
godot_bool go_godot_array_has(godot_gdnative_core_api_struct * p_api, const godot_array * p_self, const godot_variant * p_value);
godot_int go_godot_array_hash(godot_gdnative_core_api_struct * p_api, const godot_array * p_self);
void go_godot_array_insert(godot_gdnative_core_api_struct * p_api, godot_array * p_self, const godot_int p_pos, const godot_variant * p_value);
void go_godot_array_invert(godot_gdnative_core_api_struct * p_api, godot_array * p_self);
godot_variant go_godot_array_pop_back(godot_gdnative_core_api_struct * p_api, godot_array * p_self);
godot_variant go_godot_array_pop_front(godot_gdnative_core_api_struct * p_api, godot_array * p_self);
void go_godot_array_push_back(godot_gdnative_core_api_struct * p_api, godot_array * p_self, const godot_variant * p_value);
void go_godot_array_push_front(godot_gdnative_core_api_struct * p_api, godot_array * p_self, const godot_variant * p_value);
void go_godot_array_remove(godot_gdnative_core_api_struct * p_api, godot_array * p_self, const godot_int p_idx);
void go_godot_array_resize(godot_gdnative_core_api_struct * p_api, godot_array * p_self, const godot_int p_size);
godot_int go_godot_array_rfind(godot_gdnative_core_api_struct * p_api, const godot_array * p_self, const godot_variant * p_what, const godot_int p_from);
godot_int go_godot_array_size(godot_gdnative_core_api_struct * p_api, const godot_array * p_self);
void go_godot_array_sort(godot_gdnative_core_api_struct * p_api, godot_array * p_self);
void go_godot_array_sort_custom(godot_gdnative_core_api_struct * p_api, godot_array * p_self, godot_object * p_obj, const godot_string * p_func);
godot_int go_godot_array_bsearch(godot_gdnative_core_api_struct * p_api, godot_array * p_self, const godot_variant * p_value, const godot_bool p_before);
godot_int go_godot_array_bsearch_custom(godot_gdnative_core_api_struct * p_api, godot_array * p_self, const godot_variant * p_value, godot_object * p_obj, const godot_string * p_func, const godot_bool p_before);
void go_godot_array_destroy(godot_gdnative_core_api_struct * p_api, godot_array * p_self);
void go_godot_dictionary_new(godot_gdnative_core_api_struct * p_api, godot_dictionary * r_dest);
void go_godot_dictionary_new_copy(godot_gdnative_core_api_struct * p_api, godot_dictionary * r_dest, const godot_dictionary * p_src);
void go_godot_dictionary_destroy(godot_gdnative_core_api_struct * p_api, godot_dictionary * p_self);
godot_int go_godot_dictionary_size(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self);
godot_bool go_godot_dictionary_empty(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self);
void go_godot_dictionary_clear(godot_gdnative_core_api_struct * p_api, godot_dictionary * p_self);
godot_bool go_godot_dictionary_has(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self, const godot_variant * p_key);
godot_bool go_godot_dictionary_has_all(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self, const godot_array * p_keys);
void go_godot_dictionary_erase(godot_gdnative_core_api_struct * p_api, godot_dictionary * p_self, const godot_variant * p_key);
godot_int go_godot_dictionary_hash(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self);
godot_array go_godot_dictionary_keys(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self);
godot_array go_godot_dictionary_values(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self);
godot_variant go_godot_dictionary_get(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self, const godot_variant * p_key);
void go_godot_dictionary_set(godot_gdnative_core_api_struct * p_api, godot_dictionary * p_self, const godot_variant * p_key, const godot_variant * p_value);
godot_variant * go_godot_dictionary_operator_index(godot_gdnative_core_api_struct * p_api, godot_dictionary * p_self, const godot_variant * p_key);
const godot_variant * go_godot_dictionary_operator_index_const(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self, const godot_variant * p_key);
godot_variant * go_godot_dictionary_next(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self, const godot_variant * p_key);
godot_bool go_godot_dictionary_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self, const godot_dictionary * p_b);
godot_string go_godot_dictionary_to_json(godot_gdnative_core_api_struct * p_api, const godot_dictionary * p_self);
void go_godot_node_path_new(godot_gdnative_core_api_struct * p_api, godot_node_path * r_dest, const godot_string * p_from);
void go_godot_node_path_new_copy(godot_gdnative_core_api_struct * p_api, godot_node_path * r_dest, const godot_node_path * p_src);
void go_godot_node_path_destroy(godot_gdnative_core_api_struct * p_api, godot_node_path * p_self);
godot_string go_godot_node_path_as_string(godot_gdnative_core_api_struct * p_api, const godot_node_path * p_self);
godot_bool go_godot_node_path_is_absolute(godot_gdnative_core_api_struct * p_api, const godot_node_path * p_self);
godot_int go_godot_node_path_get_name_count(godot_gdnative_core_api_struct * p_api, const godot_node_path * p_self);
godot_string go_godot_node_path_get_name(godot_gdnative_core_api_struct * p_api, const godot_node_path * p_self, const godot_int p_idx);
godot_int go_godot_node_path_get_subname_count(godot_gdnative_core_api_struct * p_api, const godot_node_path * p_self);
godot_string go_godot_node_path_get_subname(godot_gdnative_core_api_struct * p_api, const godot_node_path * p_self, const godot_int p_idx);
godot_string go_godot_node_path_get_concatenated_subnames(godot_gdnative_core_api_struct * p_api, const godot_node_path * p_self);
godot_bool go_godot_node_path_is_empty(godot_gdnative_core_api_struct * p_api, const godot_node_path * p_self);
godot_bool go_godot_node_path_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_node_path * p_self, const godot_node_path * p_b);
void go_godot_plane_new_with_reals(godot_gdnative_core_api_struct * p_api, godot_plane * r_dest, const godot_real p_a, const godot_real p_b, const godot_real p_c, const godot_real p_d);
void go_godot_plane_new_with_vectors(godot_gdnative_core_api_struct * p_api, godot_plane * r_dest, const godot_vector3 * p_v1, const godot_vector3 * p_v2, const godot_vector3 * p_v3);
void go_godot_plane_new_with_normal(godot_gdnative_core_api_struct * p_api, godot_plane * r_dest, const godot_vector3 * p_normal, const godot_real p_d);
godot_string go_godot_plane_as_string(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self);
godot_plane go_godot_plane_normalized(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self);
godot_vector3 go_godot_plane_center(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self);
godot_vector3 go_godot_plane_get_any_point(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self);
godot_bool go_godot_plane_is_point_over(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self, const godot_vector3 * p_point);
godot_real go_godot_plane_distance_to(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self, const godot_vector3 * p_point);
godot_bool go_godot_plane_has_point(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self, const godot_vector3 * p_point, const godot_real p_epsilon);
godot_vector3 go_godot_plane_project(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self, const godot_vector3 * p_point);
godot_bool go_godot_plane_intersect_3(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self, godot_vector3 * r_dest, const godot_plane * p_b, const godot_plane * p_c);
godot_bool go_godot_plane_intersects_ray(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self, godot_vector3 * r_dest, const godot_vector3 * p_from, const godot_vector3 * p_dir);
godot_bool go_godot_plane_intersects_segment(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self, godot_vector3 * r_dest, const godot_vector3 * p_begin, const godot_vector3 * p_end);
godot_plane go_godot_plane_operator_neg(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self);
godot_bool go_godot_plane_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self, const godot_plane * p_b);
void go_godot_plane_set_normal(godot_gdnative_core_api_struct * p_api, godot_plane * p_self, const godot_vector3 * p_normal);
godot_vector3 go_godot_plane_get_normal(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self);
godot_real go_godot_plane_get_d(godot_gdnative_core_api_struct * p_api, const godot_plane * p_self);
void go_godot_plane_set_d(godot_gdnative_core_api_struct * p_api, godot_plane * p_self, const godot_real p_d);
void go_godot_rect2_new_with_position_and_size(godot_gdnative_core_api_struct * p_api, godot_rect2 * r_dest, const godot_vector2 * p_pos, const godot_vector2 * p_size);
void go_godot_rect2_new(godot_gdnative_core_api_struct * p_api, godot_rect2 * r_dest, const godot_real p_x, const godot_real p_y, const godot_real p_width, const godot_real p_height);
godot_string go_godot_rect2_as_string(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self);
godot_real go_godot_rect2_get_area(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self);
godot_bool go_godot_rect2_intersects(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self, const godot_rect2 * p_b);
godot_bool go_godot_rect2_encloses(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self, const godot_rect2 * p_b);
godot_bool go_godot_rect2_has_no_area(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self);
godot_rect2 go_godot_rect2_clip(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self, const godot_rect2 * p_b);
godot_rect2 go_godot_rect2_merge(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self, const godot_rect2 * p_b);
godot_bool go_godot_rect2_has_point(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self, const godot_vector2 * p_point);
godot_rect2 go_godot_rect2_grow(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self, const godot_real p_by);
godot_rect2 go_godot_rect2_expand(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self, const godot_vector2 * p_to);
godot_bool go_godot_rect2_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self, const godot_rect2 * p_b);
godot_vector2 go_godot_rect2_get_position(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self);
godot_vector2 go_godot_rect2_get_size(godot_gdnative_core_api_struct * p_api, const godot_rect2 * p_self);
void go_godot_rect2_set_position(godot_gdnative_core_api_struct * p_api, godot_rect2 * p_self, const godot_vector2 * p_pos);
void go_godot_rect2_set_size(godot_gdnative_core_api_struct * p_api, godot_rect2 * p_self, const godot_vector2 * p_size);
void go_godot_aabb_new(godot_gdnative_core_api_struct * p_api, godot_aabb * r_dest, const godot_vector3 * p_pos, const godot_vector3 * p_size);
godot_vector3 go_godot_aabb_get_position(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
void go_godot_aabb_set_position(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_vector3 * p_v);
godot_vector3 go_godot_aabb_get_size(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
void go_godot_aabb_set_size(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_vector3 * p_v);
godot_string go_godot_aabb_as_string(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
godot_real go_godot_aabb_get_area(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
godot_bool go_godot_aabb_has_no_area(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
godot_bool go_godot_aabb_has_no_surface(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
godot_bool go_godot_aabb_intersects(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_aabb * p_with);
godot_bool go_godot_aabb_encloses(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_aabb * p_with);
godot_aabb go_godot_aabb_merge(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_aabb * p_with);
godot_aabb go_godot_aabb_intersection(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_aabb * p_with);
godot_bool go_godot_aabb_intersects_plane(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_plane * p_plane);
godot_bool go_godot_aabb_intersects_segment(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_vector3 * p_from, const godot_vector3 * p_to);
godot_bool go_godot_aabb_has_point(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_vector3 * p_point);
godot_vector3 go_godot_aabb_get_support(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_vector3 * p_dir);
godot_vector3 go_godot_aabb_get_longest_axis(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
godot_int go_godot_aabb_get_longest_axis_index(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
godot_real go_godot_aabb_get_longest_axis_size(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
godot_vector3 go_godot_aabb_get_shortest_axis(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
godot_int go_godot_aabb_get_shortest_axis_index(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
godot_real go_godot_aabb_get_shortest_axis_size(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self);
godot_aabb go_godot_aabb_expand(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_vector3 * p_to_point);
godot_aabb go_godot_aabb_grow(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_real p_by);
godot_vector3 go_godot_aabb_get_endpoint(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_int p_idx);
godot_bool go_godot_aabb_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_aabb * p_self, const godot_aabb * p_b);
void go_godot_rid_new(godot_gdnative_core_api_struct * p_api, godot_rid * r_dest);
godot_int go_godot_rid_get_id(godot_gdnative_core_api_struct * p_api, const godot_rid * p_self);
void go_godot_rid_new_with_resource(godot_gdnative_core_api_struct * p_api, godot_rid * r_dest, const godot_object * p_from);
godot_bool go_godot_rid_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_rid * p_self, const godot_rid * p_b);
godot_bool go_godot_rid_operator_less(godot_gdnative_core_api_struct * p_api, const godot_rid * p_self, const godot_rid * p_b);
void go_godot_transform_new_with_axis_origin(godot_gdnative_core_api_struct * p_api, godot_transform * r_dest, const godot_vector3 * p_x_axis, const godot_vector3 * p_y_axis, const godot_vector3 * p_z_axis, const godot_vector3 * p_origin);
void go_godot_transform_new(godot_gdnative_core_api_struct * p_api, godot_transform * r_dest, const godot_basis * p_basis, const godot_vector3 * p_origin);
godot_basis go_godot_transform_get_basis(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self);
void go_godot_transform_set_basis(godot_gdnative_core_api_struct * p_api, godot_transform * p_self, const godot_basis * p_v);
godot_vector3 go_godot_transform_get_origin(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self);
void go_godot_transform_set_origin(godot_gdnative_core_api_struct * p_api, godot_transform * p_self, const godot_vector3 * p_v);
godot_string go_godot_transform_as_string(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self);
godot_transform go_godot_transform_inverse(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self);
godot_transform go_godot_transform_affine_inverse(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self);
godot_transform go_godot_transform_orthonormalized(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self);
godot_transform go_godot_transform_rotated(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_vector3 * p_axis, const godot_real p_phi);
godot_transform go_godot_transform_scaled(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_vector3 * p_scale);
godot_transform go_godot_transform_translated(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_vector3 * p_ofs);
godot_transform go_godot_transform_looking_at(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_vector3 * p_target, const godot_vector3 * p_up);
godot_plane go_godot_transform_xform_plane(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_plane * p_v);
godot_plane go_godot_transform_xform_inv_plane(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_plane * p_v);
void go_godot_transform_new_identity(godot_gdnative_core_api_struct * p_api, godot_transform * r_dest);
godot_bool go_godot_transform_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_transform * p_b);
godot_transform go_godot_transform_operator_multiply(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_transform * p_b);
godot_vector3 go_godot_transform_xform_vector3(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_vector3 * p_v);
godot_vector3 go_godot_transform_xform_inv_vector3(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_vector3 * p_v);
godot_aabb go_godot_transform_xform_aabb(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_aabb * p_v);
godot_aabb go_godot_transform_xform_inv_aabb(godot_gdnative_core_api_struct * p_api, const godot_transform * p_self, const godot_aabb * p_v);
void go_godot_transform2d_new(godot_gdnative_core_api_struct * p_api, godot_transform2d * r_dest, const godot_real p_rot, const godot_vector2 * p_pos);
void go_godot_transform2d_new_axis_origin(godot_gdnative_core_api_struct * p_api, godot_transform2d * r_dest, const godot_vector2 * p_x_axis, const godot_vector2 * p_y_axis, const godot_vector2 * p_origin);
godot_string go_godot_transform2d_as_string(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self);
godot_transform2d go_godot_transform2d_inverse(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self);
godot_transform2d go_godot_transform2d_affine_inverse(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self);
godot_real go_godot_transform2d_get_rotation(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self);
godot_vector2 go_godot_transform2d_get_origin(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self);
godot_vector2 go_godot_transform2d_get_scale(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self);
godot_transform2d go_godot_transform2d_orthonormalized(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self);
godot_transform2d go_godot_transform2d_rotated(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_real p_phi);
godot_transform2d go_godot_transform2d_scaled(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_vector2 * p_scale);
godot_transform2d go_godot_transform2d_translated(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_vector2 * p_offset);
godot_vector2 go_godot_transform2d_xform_vector2(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_vector2 * p_v);
godot_vector2 go_godot_transform2d_xform_inv_vector2(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_vector2 * p_v);
godot_vector2 go_godot_transform2d_basis_xform_vector2(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_vector2 * p_v);
godot_vector2 go_godot_transform2d_basis_xform_inv_vector2(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_vector2 * p_v);
godot_transform2d go_godot_transform2d_interpolate_with(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_transform2d * p_m, const godot_real p_c);
godot_bool go_godot_transform2d_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_transform2d * p_b);
godot_transform2d go_godot_transform2d_operator_multiply(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_transform2d * p_b);
void go_godot_transform2d_new_identity(godot_gdnative_core_api_struct * p_api, godot_transform2d * r_dest);
godot_rect2 go_godot_transform2d_xform_rect2(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_rect2 * p_v);
godot_rect2 go_godot_transform2d_xform_inv_rect2(godot_gdnative_core_api_struct * p_api, const godot_transform2d * p_self, const godot_rect2 * p_v);
godot_variant_type go_godot_variant_get_type(godot_gdnative_core_api_struct * p_api, const godot_variant * p_v);
void go_godot_variant_new_copy(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_variant * p_src);
void go_godot_variant_new_nil(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest);
void go_godot_variant_new_bool(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_bool p_b);
void go_godot_variant_new_uint(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const uint64_t p_i);
void go_godot_variant_new_int(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const int64_t p_i);
void go_godot_variant_new_real(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const double p_r);
void go_godot_variant_new_string(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_string * p_s);
void go_godot_variant_new_vector2(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_vector2 * p_v2);
void go_godot_variant_new_rect2(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_rect2 * p_rect2);
void go_godot_variant_new_vector3(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_vector3 * p_v3);
void go_godot_variant_new_transform2d(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_transform2d * p_t2d);
void go_godot_variant_new_plane(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_plane * p_plane);
void go_godot_variant_new_quat(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_quat * p_quat);
void go_godot_variant_new_aabb(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_aabb * p_aabb);
void go_godot_variant_new_basis(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_basis * p_basis);
void go_godot_variant_new_transform(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_transform * p_trans);
void go_godot_variant_new_color(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_color * p_color);
void go_godot_variant_new_node_path(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_node_path * p_np);
void go_godot_variant_new_rid(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_rid * p_rid);
void go_godot_variant_new_object(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_object * p_obj);
void go_godot_variant_new_dictionary(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_dictionary * p_dict);
void go_godot_variant_new_array(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_array * p_arr);
void go_godot_variant_new_pool_byte_array(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_pool_byte_array * p_pba);
void go_godot_variant_new_pool_int_array(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_pool_int_array * p_pia);
void go_godot_variant_new_pool_real_array(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_pool_real_array * p_pra);
void go_godot_variant_new_pool_string_array(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_pool_string_array * p_psa);
void go_godot_variant_new_pool_vector2_array(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_pool_vector2_array * p_pv2a);
void go_godot_variant_new_pool_vector3_array(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_pool_vector3_array * p_pv3a);
void go_godot_variant_new_pool_color_array(godot_gdnative_core_api_struct * p_api, godot_variant * r_dest, const godot_pool_color_array * p_pca);
godot_bool go_godot_variant_as_bool(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
uint64_t go_godot_variant_as_uint(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
int64_t go_godot_variant_as_int(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
double go_godot_variant_as_real(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_string go_godot_variant_as_string(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_vector2 go_godot_variant_as_vector2(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_rect2 go_godot_variant_as_rect2(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_vector3 go_godot_variant_as_vector3(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_transform2d go_godot_variant_as_transform2d(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_plane go_godot_variant_as_plane(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_quat go_godot_variant_as_quat(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_aabb go_godot_variant_as_aabb(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_basis go_godot_variant_as_basis(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_transform go_godot_variant_as_transform(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_color go_godot_variant_as_color(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_node_path go_godot_variant_as_node_path(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_rid go_godot_variant_as_rid(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_object * go_godot_variant_as_object(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_dictionary go_godot_variant_as_dictionary(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_array go_godot_variant_as_array(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_pool_byte_array go_godot_variant_as_pool_byte_array(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_pool_int_array go_godot_variant_as_pool_int_array(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_pool_real_array go_godot_variant_as_pool_real_array(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_pool_string_array go_godot_variant_as_pool_string_array(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_pool_vector2_array go_godot_variant_as_pool_vector2_array(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_pool_vector3_array go_godot_variant_as_pool_vector3_array(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_pool_color_array go_godot_variant_as_pool_color_array(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
godot_variant go_godot_variant_call(godot_gdnative_core_api_struct * p_api, godot_variant * p_self, const godot_string * p_method, const godot_variant ** p_args, const godot_int p_argcount, godot_variant_call_error * r_error);
godot_bool go_godot_variant_has_method(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self, const godot_string * p_method);
godot_bool go_godot_variant_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self, const godot_variant * p_other);
godot_bool go_godot_variant_operator_less(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self, const godot_variant * p_other);
godot_bool go_godot_variant_hash_compare(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self, const godot_variant * p_other);
godot_bool go_godot_variant_booleanize(godot_gdnative_core_api_struct * p_api, const godot_variant * p_self);
void go_godot_variant_destroy(godot_gdnative_core_api_struct * p_api, godot_variant * p_self);
godot_int go_godot_char_string_length(godot_gdnative_core_api_struct * p_api, const godot_char_string * p_cs);
const char * go_godot_char_string_get_data(godot_gdnative_core_api_struct * p_api, const godot_char_string * p_cs);
void go_godot_char_string_destroy(godot_gdnative_core_api_struct * p_api, godot_char_string * p_cs);
void go_godot_string_new(godot_gdnative_core_api_struct * p_api, godot_string * r_dest);
void go_godot_string_new_copy(godot_gdnative_core_api_struct * p_api, godot_string * r_dest, const godot_string * p_src);
void go_godot_string_new_with_wide_string(godot_gdnative_core_api_struct * p_api, godot_string * r_dest, const wchar_t * p_contents, const int p_size);
const wchar_t * go_godot_string_operator_index(godot_gdnative_core_api_struct * p_api, godot_string * p_self, const godot_int p_idx);
wchar_t go_godot_string_operator_index_const(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_int p_idx);
const wchar_t * go_godot_string_wide_str(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_bool go_godot_string_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_b);
godot_bool go_godot_string_operator_less(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_b);
godot_string go_godot_string_operator_plus(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_b);
godot_int go_godot_string_length(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
signed char go_godot_string_casecmp_to(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_str);
signed char go_godot_string_nocasecmp_to(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_str);
signed char go_godot_string_naturalnocasecmp_to(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_str);
godot_bool go_godot_string_begins_with(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_string);
godot_bool go_godot_string_begins_with_char_array(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const char * p_char_array);
godot_array go_godot_string_bigrams(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_chr(godot_gdnative_core_api_struct * p_api, wchar_t p_character);
godot_bool go_godot_string_ends_with(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_string);
godot_int go_godot_string_find(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_what);
godot_int go_godot_string_find_from(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_what, godot_int p_from);
godot_int go_godot_string_findmk(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_array * p_keys);
godot_int go_godot_string_findmk_from(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_array * p_keys, godot_int p_from);
godot_int go_godot_string_findmk_from_in_place(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_array * p_keys, godot_int p_from, godot_int * r_key);
godot_int go_godot_string_findn(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_what);
godot_int go_godot_string_findn_from(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_what, godot_int p_from);
godot_int go_godot_string_find_last(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_what);
godot_string go_godot_string_format(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_variant * p_values);
godot_string go_godot_string_format_with_custom_placeholder(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_variant * p_values, const char * p_placeholder);
godot_string go_godot_string_hex_encode_buffer(godot_gdnative_core_api_struct * p_api, const uint8_t * p_buffer, godot_int p_len);
godot_int go_godot_string_hex_to_int(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_int go_godot_string_hex_to_int_without_prefix(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_insert(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_at_pos, godot_string p_string);
godot_bool go_godot_string_is_numeric(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_bool go_godot_string_is_subsequence_of(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_string);
godot_bool go_godot_string_is_subsequence_ofi(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_string);
godot_string go_godot_string_lpad(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_min_length);
godot_string go_godot_string_lpad_with_custom_character(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_min_length, const godot_string * p_character);
godot_bool go_godot_string_match(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_wildcard);
godot_bool go_godot_string_matchn(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_wildcard);
godot_string go_godot_string_md5(godot_gdnative_core_api_struct * p_api, const uint8_t * p_md5);
godot_string go_godot_string_num(godot_gdnative_core_api_struct * p_api, double p_num);
godot_string go_godot_string_num_int64(godot_gdnative_core_api_struct * p_api, int64_t p_num, godot_int p_base);
godot_string go_godot_string_num_int64_capitalized(godot_gdnative_core_api_struct * p_api, int64_t p_num, godot_int p_base, godot_bool p_capitalize_hex);
godot_string go_godot_string_num_real(godot_gdnative_core_api_struct * p_api, double p_num);
godot_string go_godot_string_num_scientific(godot_gdnative_core_api_struct * p_api, double p_num);
godot_string go_godot_string_num_with_decimals(godot_gdnative_core_api_struct * p_api, double p_num, godot_int p_decimals);
godot_string go_godot_string_pad_decimals(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_digits);
godot_string go_godot_string_pad_zeros(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_digits);
godot_string go_godot_string_replace_first(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_key, godot_string p_with);
godot_string go_godot_string_replace(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_key, godot_string p_with);
godot_string go_godot_string_replacen(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_key, godot_string p_with);
godot_int go_godot_string_rfind(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_what);
godot_int go_godot_string_rfindn(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_what);
godot_int go_godot_string_rfind_from(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_what, godot_int p_from);
godot_int go_godot_string_rfindn_from(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_what, godot_int p_from);
godot_string go_godot_string_rpad(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_min_length);
godot_string go_godot_string_rpad_with_custom_character(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_min_length, const godot_string * p_character);
godot_real go_godot_string_similarity(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_string);
godot_string go_godot_string_sprintf(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_array * p_values, godot_bool * p_error);
godot_string go_godot_string_substr(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_from, godot_int p_chars);
double go_godot_string_to_double(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_real go_godot_string_to_float(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_int go_godot_string_to_int(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_camelcase_to_underscore(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_camelcase_to_underscore_lowercased(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_capitalize(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
double go_godot_string_char_to_double(godot_gdnative_core_api_struct * p_api, const char * p_what);
godot_int go_godot_string_char_to_int(godot_gdnative_core_api_struct * p_api, const char * p_what);
int64_t go_godot_string_wchar_to_int(godot_gdnative_core_api_struct * p_api, const wchar_t * p_str);
godot_int go_godot_string_char_to_int_with_len(godot_gdnative_core_api_struct * p_api, const char * p_what, godot_int p_len);
int64_t go_godot_string_char_to_int64_with_len(godot_gdnative_core_api_struct * p_api, const wchar_t * p_str, int p_len);
int64_t go_godot_string_hex_to_int64(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
int64_t go_godot_string_hex_to_int64_with_prefix(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
int64_t go_godot_string_to_int64(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
double go_godot_string_unicode_char_to_double(godot_gdnative_core_api_struct * p_api, const wchar_t * p_str, const wchar_t ** r_end);
godot_int go_godot_string_get_slice_count(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_splitter);
godot_string go_godot_string_get_slice(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_string p_splitter, godot_int p_slice);
godot_string go_godot_string_get_slicec(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, wchar_t p_splitter, godot_int p_slice);
godot_array go_godot_string_split(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_splitter);
godot_array go_godot_string_split_allow_empty(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_splitter);
godot_array go_godot_string_split_floats(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_splitter);
godot_array go_godot_string_split_floats_allows_empty(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_splitter);
godot_array go_godot_string_split_floats_mk(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_array * p_splitters);
godot_array go_godot_string_split_floats_mk_allows_empty(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_array * p_splitters);
godot_array go_godot_string_split_ints(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_splitter);
godot_array go_godot_string_split_ints_allows_empty(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_splitter);
godot_array go_godot_string_split_ints_mk(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_array * p_splitters);
godot_array go_godot_string_split_ints_mk_allows_empty(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_array * p_splitters);
godot_array go_godot_string_split_spaces(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
wchar_t go_godot_string_char_lowercase(godot_gdnative_core_api_struct * p_api, wchar_t p_char);
wchar_t go_godot_string_char_uppercase(godot_gdnative_core_api_struct * p_api, wchar_t p_char);
godot_string go_godot_string_to_lower(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_to_upper(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_get_basename(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_get_extension(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_left(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_pos);
wchar_t go_godot_string_ord_at(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_idx);
godot_string go_godot_string_plus_file(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_file);
godot_string go_godot_string_right(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_pos);
godot_string go_godot_string_strip_edges(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_bool p_left, godot_bool p_right);
godot_string go_godot_string_strip_escapes(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
void go_godot_string_erase(godot_gdnative_core_api_struct * p_api, godot_string * p_self, godot_int p_pos, godot_int p_chars);
godot_char_string go_godot_string_ascii(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_char_string go_godot_string_ascii_extended(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_char_string go_godot_string_utf8(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_bool go_godot_string_parse_utf8(godot_gdnative_core_api_struct * p_api, godot_string * p_self, const char * p_utf8);
godot_bool go_godot_string_parse_utf8_with_len(godot_gdnative_core_api_struct * p_api, godot_string * p_self, const char * p_utf8, godot_int p_len);
godot_string go_godot_string_chars_to_utf8(godot_gdnative_core_api_struct * p_api, const char * p_utf8);
godot_string go_godot_string_chars_to_utf8_with_len(godot_gdnative_core_api_struct * p_api, const char * p_utf8, godot_int p_len);
uint32_t go_godot_string_hash(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
uint64_t go_godot_string_hash64(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
uint32_t go_godot_string_hash_chars(godot_gdnative_core_api_struct * p_api, const char * p_cstr);
uint32_t go_godot_string_hash_chars_with_len(godot_gdnative_core_api_struct * p_api, const char * p_cstr, godot_int p_len);
uint32_t go_godot_string_hash_utf8_chars(godot_gdnative_core_api_struct * p_api, const wchar_t * p_str);
uint32_t go_godot_string_hash_utf8_chars_with_len(godot_gdnative_core_api_struct * p_api, const wchar_t * p_str, godot_int p_len);
godot_pool_byte_array go_godot_string_md5_buffer(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_md5_text(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_pool_byte_array go_godot_string_sha256_buffer(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_sha256_text(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_bool go_godot_string_empty(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_get_base_dir(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_get_file(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_humanize_size(godot_gdnative_core_api_struct * p_api, uint64_t p_size);
godot_bool go_godot_string_is_abs_path(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_bool go_godot_string_is_rel_path(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_bool go_godot_string_is_resource_file(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_path_to(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_path);
godot_string go_godot_string_path_to_file(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, const godot_string * p_path);
godot_string go_godot_string_simplify_path(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_c_escape(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_c_escape_multiline(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_c_unescape(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_http_escape(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_http_unescape(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_json_escape(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_word_wrap(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_int p_chars_per_line);
godot_string go_godot_string_xml_escape(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_xml_escape_with_quotes(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_xml_unescape(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_percent_decode(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_string go_godot_string_percent_encode(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_bool go_godot_string_is_valid_float(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_bool go_godot_string_is_valid_hex_number(godot_gdnative_core_api_struct * p_api, const godot_string * p_self, godot_bool p_with_prefix);
godot_bool go_godot_string_is_valid_html_color(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_bool go_godot_string_is_valid_identifier(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_bool go_godot_string_is_valid_integer(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
godot_bool go_godot_string_is_valid_ip_address(godot_gdnative_core_api_struct * p_api, const godot_string * p_self);
void go_godot_string_destroy(godot_gdnative_core_api_struct * p_api, godot_string * p_self);
void go_godot_string_name_new(godot_gdnative_core_api_struct * p_api, godot_string_name * r_dest, const godot_string * p_name);
void go_godot_string_name_new_data(godot_gdnative_core_api_struct * p_api, godot_string_name * r_dest, const char * p_name);
godot_string go_godot_string_name_get_name(godot_gdnative_core_api_struct * p_api, const godot_string_name * p_self);
uint32_t go_godot_string_name_get_hash(godot_gdnative_core_api_struct * p_api, const godot_string_name * p_self);
const void * go_godot_string_name_get_data_unique_pointer(godot_gdnative_core_api_struct * p_api, const godot_string_name * p_self);
godot_bool go_godot_string_name_operator_equal(godot_gdnative_core_api_struct * p_api, const godot_string_name * p_self, const godot_string_name * p_other);
godot_bool go_godot_string_name_operator_less(godot_gdnative_core_api_struct * p_api, const godot_string_name * p_self, const godot_string_name * p_other);
void go_godot_string_name_destroy(godot_gdnative_core_api_struct * p_api, godot_string_name * p_self);
void go_godot_object_destroy(godot_gdnative_core_api_struct * p_api, godot_object * p_o);
godot_object * go_godot_global_get_singleton(godot_gdnative_core_api_struct * p_api, char * p_name);
godot_method_bind * go_godot_method_bind_get_method(godot_gdnative_core_api_struct * p_api, const char * p_classname, const char * p_methodname);
void go_godot_method_bind_ptrcall(godot_gdnative_core_api_struct * p_api, godot_method_bind * p_method_bind, godot_object * p_instance, const void ** p_args, void * p_ret);
godot_variant go_godot_method_bind_call(godot_gdnative_core_api_struct * p_api, godot_method_bind * p_method_bind, godot_object * p_instance, const godot_variant ** p_args, const int p_arg_count, godot_variant_call_error * p_call_error);
godot_class_constructor go_godot_get_class_constructor(godot_gdnative_core_api_struct * p_api, const char * p_classname);
godot_dictionary go_godot_get_global_constants(godot_gdnative_core_api_struct * p_api);
void go_godot_register_native_call_type(godot_gdnative_core_api_struct * p_api, const char * call_type, native_call_cb p_callback);
void * go_godot_alloc(godot_gdnative_core_api_struct * p_api, int p_bytes);
void * go_godot_realloc(godot_gdnative_core_api_struct * p_api, void * p_ptr, int p_bytes);
void go_godot_free(godot_gdnative_core_api_struct * p_api, void * p_ptr);
void go_godot_print_error(godot_gdnative_core_api_struct * p_api, const char * p_description, const char * p_function, const char * p_file, int p_line);
void go_godot_print_warning(godot_gdnative_core_api_struct * p_api, const char * p_description, const char * p_function, const char * p_file, int p_line);
void go_godot_print(godot_gdnative_core_api_struct * p_api, const godot_string * p_message);
#endif
